# Bases de Datos Nosql y SQL

Las bases de datos NoSQL están dirigidas a modelos no relacionales que guardan los datos en documentos tipo JSON, tuplas de clave-valor, grafos o columnas. El tipo de dato ofrece flexibilidad porque los registros no almacenan las mismas propiedades. Además, las nuevas propiedades pueden añadirse al vuelo y las relaciones suelen capturarse denormalizando los datos. Es bueno para datos semi estructurados. También, los esquemas a los que se orienta son dinámicos, es decir el esquema de la base de datos es controlado por la aplicación proporcionando agilidad y eficiencia en desarrollos iterativos.
	
SQL está dirigidos a modelos relacionales que guardan los datos en una tabla. El tipo de dato es ideal cuando los registros tienen las mismas propiedades. Las nuevas propiedades implican alterar el esquema y las relaciones suelen capturarse usando joins para resolver referencias en el cruce de tablas. Es bueno para datos completamente estructurados. También, los esquemas a los que se orienta rígidos, es decir el esquema de la base de datos debe de ser mantenido y guardado en armonía y sincronización entre la aplicación y la base de datos proporcionando una gran consistencia.

De esta forma, podemos deducir de carácter general las ventajas e inconvenientes entre una base de datos relacional y una NoSQL, obviamente las bases de datos NoSQL heredarán las características.

## Las desventajas de una base de datos relacional frente a las ventajas de una base de datos NoSQL.
En las bases de datos relacionales, la problemática suele ser  la atomicidad de las operaciones (la operación si se hace es de principio a fin) reduce el rendimiento de las bases de datos. También, la escalabilidad suele ser por norma general inferior a las bases de datos NoSQL.

## Ventajas de una base de datos relacional frente las desventajas de una base de datos NoSQL.
Las ventajas de una base de datos relacional derivan mayoritariamente de llevar más tiempo funcionando. Por ello, están más adaptadas al uso que la gente le da, los perfiles que emplean son muy conocidos y hay una mayor cantidad de usuario que la usan. Además, tienen mayor soporte y suites con productos y addons para gestionarlas.

La atomicidad en las operaciones puede resultar un punto a favor si realmente se quiere que las operación se haga solamente si llega al final (si no lo hace no se ejecuta) utilizando el rollback. Estas bases de datos son caracteristicas por cumpir unos requisitos exahustivos de integridad, tanto en tipo de dato como en compatibilidad de este.

Por otro lado las desventajas de una base de datos NoSQL suele empezar precisamente porque no todas las NoSQL contemplan la atomicidad de las operaciones y la integridad de los datos, tienen una consistencia eventual. 

Suelen tener problemas entre instrucciones SQL ya que las nuevas bases de datos utilizan sus propias características en el lenguaje y no tiene porque haber un alto porcentaje de compatibilidad con el lenguaje SQL  característico de las bases de datos relacionales, además, el soporte a problemas derivados de las consultas en NoSQL suele ser más complicado.

Como todo lo relativamente nuevo, no hay una estandarización, por lo que hay muchas NoSQL cada una con sus características sin seguir el estándar que si que se tendría para una base de datos relacional.

Actualmente, y ya se está mejorando, algunas NoSQL no soportan multiplataforma o tienen restricciones en algunos sistemas operativos que no sean una distribución de Linux. Además, en algunos casos la administración puede ser no muy usable o únicamente por consola, algunos programas de terceros se encargan de suplir este inconveniente.